﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Controls;
using System.Windows.Shapes;
using System.Windows.Media;
using System.Windows;

namespace Seminar05_Mo
{
    class Datenreihe
    {
        string name;
        Strichart strich;
        List<Tuple<double, double>> daten = new List<Tuple<double, double>>();

        public Datenreihe(string dateiname)
        {
            // TODO: Exceptions behandeln
            StreamReader sr = new StreamReader(dateiname);
            name = sr.ReadLine();
            while (!sr.EndOfStream)
            {
                string zeile = sr.ReadLine();
                string[] a = zeile.Split(';');
                double x = double.Parse(a[0]);
                double y = double.Parse(a[1]);
                Tuple<double, double> t = new Tuple<double, double>(x, y);
                daten.Add(t);
            }
            sr.Close();
            daten = daten.OrderBy(p => p.Item1).ToList(); // weiß man nicht auswendig
        }

        public double Xmax
        {
            get
            {
                return daten.Max(p => p.Item1);
            }
        }

        public double Xmin
        {
            get
            {
                return daten.Min(p => p.Item1);
            }
        }

        public double Ymax
        {
            get
            {
                return daten.Max(p => p.Item2);
            }
        }

        public double Ymin
        {
            get
            {
                return daten.Min(p => p.Item2);
            }
        }

        public void Draw(Canvas canvasGraph, double maxX, double minX, double maxY, double minY)
        {
            Polyline line = new Polyline();
            line.Stroke = Brushes.Blue;
            line.StrokeThickness = 1.0;

            foreach (var p in daten)
            {
                line.Points.Add(new Point((p.Item1 - minX) * canvasGraph.ActualWidth / (maxX - minX), (maxY - p.Item2) * canvasGraph.ActualHeight / (maxY - minY)));
            }

            canvasGraph.Children.Add(line);
        }
    }
}
